import { Controller, Get, Inject } from '@midwayjs/decorator';
import { ViewService } from '../service/view.service';
import { Context } from '@midwayjs/koa';
import { ApiResponse, ApiTags } from '@midwayjs/swagger';
@ApiTags(['视图'])
@Controller('/view')
export class ViewController {
  @Inject()
  service: ViewService;
  @Inject()
  ctx: Context;

  @Get('/dataView/:id')
  @ApiResponse({})
  async dataView() {
    const data = await this.service.dataView(this.ctx.params);
    return data;
  }
}
