import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { Decimal128 } from 'mongoose';
@modelOptions({
  schemaOptions: { collection: 'achieve' },
})
export class Achieve extends BaseModel {
  @prop({ required: false, index: true, zh: '用户', ref: 'Basic' })
  user: string;
  @prop({ required: false, index: true, zh: '项目', ref: 'Science' })
  science: string;
  @prop({ required: false, index: true, zh: '类型', remark: '字典' })
  type: string;
  @prop({ required: false, index: true, zh: '成果名称' })
  name: string;
  @prop({ required: false, index: true, zh: '合作单位' })
  unit: string;
  @prop({ required: false, index: false, zh: '合作单位类型', remark: '字典' })
  unit_type: string;
  @prop({ required: false, index: false, zh: '金额(万元)' })
  money: Decimal128;
  @prop({ required: false, index: true, zh: '合作方式' })
  way: string;
  @prop({ required: false, index: true, zh: '完成时间' })
  time: string;
  @prop({ required: false, index: false, zh: '附件' })
  file: Array<any>;
}
