import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'award' },
})
export class Award extends BaseModel {
  @prop({ required: false, index: true, zh: '用户', ref: 'Basic' })
  user: string;
  @prop({ required: false, index: true, zh: '项目', ref: 'Science' })
  science: string;
  @prop({ required: false, index: true, zh: '类别', remark: '字典' })
  type: string;
  @prop({ required: false, index: true, zh: '成果编号' })
  no: string;
  @prop({ required: false, index: true, zh: '成果名称' })
  name: string;
  @prop({ required: false, index: true, zh: '获奖等级', remark: '字典' })
  level: string;
  @prop({ required: false, index: true, zh: '研究方向' })
  direction: string;
  @prop({ required: false, index: false, zh: '获奖人' })
  participant: Array<any>;
  @prop({ required: false, index: false, zh: '附件' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '成果简介' })
  content: string;
  @prop({ required: false, index: true, zh: '获奖时间' })
  time: string;
}
