import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'guide' },
})
export class Guide extends BaseModel {
  @prop({ required: false, index: true, zh: '用户', ref: 'Basic' })
  user: string;
  @prop({
    required: false,
    index: true,
    zh: '项目名称',
    remark: '填写/选择(?)',
  })
  name: string;
  @prop({
    required: false,
    index: true,
    zh: '申请代码',
    remark: '选择,至多2个',
  })
  apply_code: Array<any>;
  @prop({ required: false, index: true, zh: '所属领域', remark: '选择' })
  field: string;
  @prop({ required: false, index: false, zh: '问题来源' })
  source: string;
  @prop({ required: false, index: false, zh: '企业科技问题' })
  question: string;
  @prop({ required: false, index: true, zh: '建议单位', remark: '依托单位' })
  unit: string;
  @prop({ required: false, index: true, zh: '建议人姓名' })
  suggestor: string;
  @prop({ required: false, index: false, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: false, zh: '现状分析' })
  analysis: string;
  @prop({ required: false, index: false, zh: '产业影响' })
  influence: string;
  @prop({ required: false, index: true, zh: '填写人' })
  opera_name: string;
  @prop({ required: false, index: false, zh: '填写人联系电话' })
  opera_phone: string;
  @prop({
    required: false,
    index: true,
    zh: '审核状态',
    remark: '字典',
    default: '0',
  })
  status: string;
  @prop({ required: false, index: false, zh: '项目建议人基本信息' })
  basicList: Array<any>;
  @prop({ required: false, index: false, zh: '系统填报基本信息' })
  systemList: Array<any>;
  @prop({ required: false, index: false, zh: '填报日期' })
  time: string;
  @prop({ required: false, index: false, zh: '研究方向' })
  direction: string;
  @prop({ required: false, index: false, zh: '研究目标' })
  target: string;
  @prop({ required: false, index: false, zh: '研究意义' })
  meaning: string;
  @prop({ required: false, index: false, zh: '国内外研究现状' })
  situation: string;
  @prop({
    required: false,
    index: false,
    zh: '应用前景（对吉林省相关行业或产业的重大影响和作用）',
  })
  foreground: string;
  @prop({ required: false, index: false, zh: '现有工作基础' })
  work: string;
  @prop({ required: false, index: false, zh: '拟解决重大科学问题' })
  todo: string;
  @prop({ required: false, index: false, zh: '研究内容' })
  context: string;
}
