import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'guideRecord' },
})
export class GuideRecord extends BaseModel {
  @prop({ required: false, index: true, zh: '项目指南建议', ref: 'Guide' })
  guide: string;
  @prop({ required: false, index: true, zh: '审核时间' })
  time: string;
  @prop({
    required: false,
    index: false,
    zh: '审核状态',
    remark: '字典:guide_status',
  })
  status: string;
  @prop({ required: false, index: false, zh: '审核意见' })
  desc: string;
  @prop({ required: false, index: false, zh: '操作人', ref: 'User' })
  operator: string;
}
