import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'menus' },
})
export class Menus extends BaseModel {
  @prop({ required: false, index: false, zh: '菜单名称' })
  name: string;
  @prop({ required: false, index: false, zh: '父级菜单' })
  parent_id: string;
  @prop({ required: false, index: false, zh: '显示顺序' })
  order_num: number;
  @prop({ required: false, index: false, zh: '路由地址' })
  path: string;
  @prop({ required: false, index: false, zh: '组件地址' })
  component: string;
  @prop({ required: false, index: false, zh: '菜单类型' })
  type: string;
  @prop({ required: false, index: false, zh: '状态', default: '0' })
  status: string;
  @prop({ required: false, index: false, zh: '图标' })
  icon: string;
  @prop({ required: false, index: false, zh: '设置' })
  config: object;
  @prop({ required: false, index: false, zh: '备注' })
  remark: string;
}
