import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'paper' },
})
export class Paper extends BaseModel {
  @prop({
    required: false,
    index: true,
    zh: '用户',
    ref: 'Basic',
    remark: '需要关联',
  })
  user: string;
  @prop({ required: false, index: true, zh: '项目', ref: 'Science' })
  science: string;
  @prop({ required: false, index: true, zh: '论文题目' })
  title: string;
  @prop({ required: false, index: false, zh: '期刊及卷号' })
  number: string;
  @prop({ required: false, index: true, zh: '论文类别', remark: '字典' })
  type: string;
  @prop({
    required: false,
    index: true,
    zh: '研究方向',
    remark: '本项目没有管理研究方向,自行填写',
  })
  direction: string;
  @prop({ required: false, index: true, zh: '作者' })
  author: string;
  @prop({ required: false, index: false, zh: '附件' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '发表时间' })
  time: string;
}
