import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { Decimal128 } from 'mongoose';
@modelOptions({
  schemaOptions: { collection: 'science' },
})
export class Science extends BaseModel {
  @prop({
    required: false,
    index: true,
    zh: '用户信息',
    ref: 'Basic',
    remark: '需要关联',
  })
  user: string;
  @prop({ required: false, index: true, zh: '依托单位' })
  unit: string;
  @prop({ required: false, index: true, zh: '项目名称' })
  name: string;
  @prop({ required: false, index: true, zh: '开始时间' })
  start_time: string;
  @prop({ required: false, index: true, zh: '结束时间' })
  end_time: string;
  @prop({ required: false, index: true, zh: '项目来源' })
  source: string;
  @prop({ required: false, index: true, zh: '项目号' })
  no: string;
  @prop({ required: false, index: false, zh: '经费' })
  money: Decimal128;
  @prop({ required: false, index: true, zh: '负责人' })
  fzuser: string;
  @prop({ required: false, index: false, zh: '主要参加人' })
  participants: Array<any>;
  @prop({ required: false, index: false, zh: '核心成员所占比例' })
  percent: string;
  @prop({
    required: false,
    index: true,
    zh: '研究方向',
    remark: '没有研究方向,只能先填写',
  })
  direction: string;
  @prop({ required: false, index: false, zh: '转化效益（万元）' })
  tran_money: Decimal128;
  @prop({ required: false, index: true, zh: '项目来源2' })
  source_two: string;
  @prop({ required: false, index: false, zh: '项目总人数' })
  person_num: number;
  @prop({ required: false, index: false, zh: '项目来源文本' })
  source_text: string;
  @prop({ required: false, index: true, zh: '状态', remark: '字典表' })
  state: string;
  @prop({ required: false, index: false, zh: '立项标准部门（单位）' })
  dept: string;
  @prop({ required: false, index: false, zh: '附件' })
  file: Array<any>;
}
