import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'user' },
})
export class User extends BaseModel {
  @prop({ required: false, index: true, zh: '用户名称' })
  name: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: false, zh: '邮箱' })
  email: string;
  @prop({
    required: false,
    index: true,
    zh: '账号',
    remark: '用户:直接用身份证;依托单位随意',
  })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: false, zh: '性别' })
  gender: string;
  @prop({ required: false, index: true, zh: '状态', remark: '0:正常;1停用' })
  status: string;
  @prop({ required: false, index: true, zh: '角色', ref: 'System.Role' })
  role: string;
  @prop({ required: false, index: true, zh: '管理员信息', ref: 'Basic' })
  basic: string;
  @prop({ required: false, index: true, zh: '依托单位', ref: 'Unit' })
  unit: string;
}
