import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_basic {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '证件类别' })
  'card_type': string = undefined;
  @ApiProperty({ description: '证件号码' })
  'num': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '出生年月' })
  'birth': string = undefined;
  @ApiProperty({ description: '联系电话' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '工作单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '办公电话' })
  'work_phone': string = undefined;
  @ApiProperty({ description: '学历' })
  'education': string = undefined;
  @ApiProperty({ description: '学位' })
  'degree': string = undefined;
  @ApiProperty({ description: '职称' })
  'title': string = undefined;
  @ApiProperty({ description: '研究领域' })
  'field': string = undefined;
}

export class QDTO_basic extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'phone'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '联系电话' })
  'phone': string = undefined;
}

export class QVO_basic extends FVO_basic {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_basic {
  @ApiProperty({ description: '姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '证件类别' })
  @Rule(RuleType['string']().empty(''))
  'card_type': string = undefined;
  @ApiProperty({ description: '证件号码' })
  @Rule(RuleType['string']().empty(''))
  'num': string = undefined;
  @ApiProperty({ description: '性别' })
  @Rule(RuleType['string']().empty(''))
  'gender': string = undefined;
  @ApiProperty({ description: '出生年月' })
  @Rule(RuleType['string']().empty(''))
  'birth': string = undefined;
  @ApiProperty({ description: '联系电话' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: '工作单位' })
  @Rule(RuleType['string']().empty(''))
  'unit': string = undefined;
  @ApiProperty({ description: '办公电话' })
  @Rule(RuleType['string']().empty(''))
  'work_phone': string = undefined;
  @ApiProperty({ description: '学历' })
  @Rule(RuleType['string']().empty(''))
  'education': string = undefined;
  @ApiProperty({ description: '学位' })
  @Rule(RuleType['string']().empty(''))
  'degree': string = undefined;
  @ApiProperty({ description: '职称' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '研究领域' })
  @Rule(RuleType['string']().empty(''))
  'field': string = undefined;
}

export class CVO_basic extends FVO_basic {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_basic extends CDTO_basic {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_basic extends FVO_basic {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
