import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dictData {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '字典编码' })
  'dict_code': string = undefined;
  @ApiProperty({ description: '字典排序' })
  'dict_sort': string = undefined;
  @ApiProperty({ description: '字典标签' })
  'dict_label': string = undefined;
  @ApiProperty({ description: '字典键值' })
  'dict_value': string = undefined;
  @ApiProperty({ description: '字典类型' })
  'dict_type': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_dictData extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_dictData extends FVO_dictData {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_dictData {
  @ApiProperty({ description: '字典编码' })
  @Rule(RuleType['string']().empty(''))
  'dict_code': string = undefined;
  @ApiProperty({ description: '字典排序' })
  @Rule(RuleType['string']().empty(''))
  'dict_sort': string = undefined;
  @ApiProperty({ description: '字典标签' })
  @Rule(RuleType['string']().empty(''))
  'dict_label': string = undefined;
  @ApiProperty({ description: '字典键值' })
  @Rule(RuleType['string']().empty(''))
  'dict_value': string = undefined;
  @ApiProperty({ description: '字典类型' })
  @Rule(RuleType['string']().empty(''))
  'dict_type': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_dictData extends FVO_dictData {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_dictData extends CDTO_dictData {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_dictData extends FVO_dictData {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
