import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dictIndex {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '字典名称' })
  'dict_name': string = undefined;
  @ApiProperty({ description: '字典类型' })
  'dict_type': string = undefined;
  @ApiProperty({ description: '状' })
  'status': string = undefined;
}

export class QDTO_dictIndex extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['dict_name', 'dict_type'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '字典名称' })
  'dict_name': string = undefined;
  @ApiProperty({ description: '字典类型' })
  'dict_type': string = undefined;
}

export class QVO_dictIndex extends FVO_dictIndex {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_dictIndex {
  @ApiProperty({ description: '字典名称' })
  @Rule(RuleType['string']().empty(''))
  'dict_name': string = undefined;
  @ApiProperty({ description: '字典类型' })
  @Rule(RuleType['string']().empty(''))
  'dict_type': string = undefined;
  @ApiProperty({ description: '状' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_dictIndex extends FVO_dictIndex {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_dictIndex extends CDTO_dictIndex {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_dictIndex extends FVO_dictIndex {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
