import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_doctor {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '指导教师' })
  'teacher': string = undefined;
  @ApiProperty({ description: '学位' })
  'degree': string = undefined;
  @ApiProperty({ description: '状态' })
  'state': string = undefined;
  @ApiProperty({ description: '完成时间' })
  'time': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
}

export class QDTO_doctor extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'user',
      'science',
      'name',
      'teacher',
      'degree',
      'state',
      'time',
      'direction',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '指导教师' })
  'teacher': string = undefined;
  @ApiProperty({ description: '学位' })
  'degree': string = undefined;
  @ApiProperty({ description: '状态' })
  'state': string = undefined;
  @ApiProperty({ description: '完成时间' })
  'time': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
}

export class QVO_doctor extends FVO_doctor {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_doctor {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  @Rule(RuleType['string']().empty(''))
  'science': string = undefined;
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '指导教师' })
  @Rule(RuleType['string']().empty(''))
  'teacher': string = undefined;
  @ApiProperty({ description: '学位' })
  @Rule(RuleType['string']().empty(''))
  'degree': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'state': string = undefined;
  @ApiProperty({ description: '完成时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '研究方向' })
  @Rule(RuleType['string']().empty(''))
  'direction': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
}

export class CVO_doctor extends FVO_doctor {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_doctor extends CDTO_doctor {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_doctor extends FVO_doctor {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
