import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_guide {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目名称' })
  'name': string = undefined;
  @ApiProperty({ description: '申请代码' })
  'apply_code': Array<any> = undefined;
  @ApiProperty({ description: '所属领域' })
  'field': string = undefined;
  @ApiProperty({ description: '问题来源' })
  'source': string = undefined;
  @ApiProperty({ description: '企业科技问题' })
  'question': string = undefined;
  @ApiProperty({ description: '建议单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '建议人姓名' })
  'suggestor': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '现状分析' })
  'analysis': string = undefined;
  @ApiProperty({ description: '产业影响' })
  'influence': string = undefined;
  @ApiProperty({ description: '填写人' })
  'opera_name': string = undefined;
  @ApiProperty({ description: '填写人联系电话' })
  'opera_phone': string = undefined;
  @ApiProperty({ description: '审核状态' })
  'status': string = undefined;
  @ApiProperty({ description: '项目建议人基本信息' })
  'basicList': Array<any> = undefined;
  @ApiProperty({ description: '系统填报基本信息' })
  'systemList': Array<any> = undefined;
  @ApiProperty({ description: '填报日期' })
  'time': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '研究目标' })
  'target': string = undefined;
  @ApiProperty({ description: '研究意义' })
  'meaning': string = undefined;
  @ApiProperty({ description: '国内外研究现状' })
  'situation': string = undefined;
  @ApiProperty({
    description: '应用前景（对吉林省相关行业或产业的重大影响和作用）',
  })
  'foreground': string = undefined;
  @ApiProperty({ description: '现有工作基础' })
  'work': string = undefined;
  @ApiProperty({ description: '拟解决重大科学问题' })
  'todo': string = undefined;
  @ApiProperty({ description: '研究内容' })
  'context': string = undefined;
}

export class QDTO_guide extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = [
      'user',
      'name',
      'apply_code',
      'field',
      'unit',
      'suggestor',
      'opera_name',
      'status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目名称' })
  'name': string = undefined;
  @ApiProperty({ description: '申请代码' })
  'apply_code': Array<any> = undefined;
  @ApiProperty({ description: '所属领域' })
  'field': string = undefined;
  @ApiProperty({ description: '建议单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '建议人姓名' })
  'suggestor': string = undefined;
  @ApiProperty({ description: '填写人' })
  'opera_name': string = undefined;
  @ApiProperty({ description: '审核状态' })
  'status': string = undefined;
}

export class QVO_guide extends FVO_guide {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_guide {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '项目名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '申请代码' })
  @Rule(RuleType['array']().empty(''))
  'apply_code': Array<any> = undefined;
  @ApiProperty({ description: '所属领域' })
  @Rule(RuleType['string']().empty(''))
  'field': string = undefined;
  @ApiProperty({ description: '问题来源' })
  @Rule(RuleType['string']().empty(''))
  'source': string = undefined;
  @ApiProperty({ description: '企业科技问题' })
  @Rule(RuleType['string']().empty(''))
  'question': string = undefined;
  @ApiProperty({ description: '建议单位' })
  @Rule(RuleType['string']().empty(''))
  'unit': string = undefined;
  @ApiProperty({ description: '建议人姓名' })
  @Rule(RuleType['string']().empty(''))
  'suggestor': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '现状分析' })
  @Rule(RuleType['string']().empty(''))
  'analysis': string = undefined;
  @ApiProperty({ description: '产业影响' })
  @Rule(RuleType['string']().empty(''))
  'influence': string = undefined;
  @ApiProperty({ description: '填写人' })
  @Rule(RuleType['string']().empty(''))
  'opera_name': string = undefined;
  @ApiProperty({ description: '填写人联系电话' })
  @Rule(RuleType['string']().empty(''))
  'opera_phone': string = undefined;
  @ApiProperty({ description: '审核状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '项目建议人基本信息' })
  @Rule(RuleType['array']().empty(''))
  'basicList': Array<any> = undefined;
  @ApiProperty({ description: '系统填报基本信息' })
  @Rule(RuleType['array']().empty(''))
  'systemList': Array<any> = undefined;
  @ApiProperty({ description: '填报日期' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '研究方向' })
  @Rule(RuleType['string']().empty(''))
  'direction': string = undefined;
  @ApiProperty({ description: '研究目标' })
  @Rule(RuleType['string']().empty(''))
  'target': string = undefined;
  @ApiProperty({ description: '研究意义' })
  @Rule(RuleType['string']().empty(''))
  'meaning': string = undefined;
  @ApiProperty({ description: '国内外研究现状' })
  @Rule(RuleType['string']().empty(''))
  'situation': string = undefined;
  @ApiProperty({
    description: '应用前景（对吉林省相关行业或产业的重大影响和作用）',
  })
  @Rule(RuleType['string']().empty(''))
  'foreground': string = undefined;
  @ApiProperty({ description: '现有工作基础' })
  @Rule(RuleType['string']().empty(''))
  'work': string = undefined;
  @ApiProperty({ description: '拟解决重大科学问题' })
  @Rule(RuleType['string']().empty(''))
  'todo': string = undefined;
  @ApiProperty({ description: '研究内容' })
  @Rule(RuleType['string']().empty(''))
  'context': string = undefined;
}

export class CVO_guide extends FVO_guide {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_guide extends CDTO_guide {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_guide extends FVO_guide {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
