import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_guideRecord {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '项目指南建议' })
  'guide': string = undefined;
  @ApiProperty({ description: '审核时间' })
  'time': string = undefined;
  @ApiProperty({ description: '审核状态' })
  'status': string = undefined;
  @ApiProperty({ description: '审核意见' })
  'desc': string = undefined;
  @ApiProperty({ description: '操作人' })
  'operator': string = undefined;
}

export class QDTO_guideRecord extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['guide', 'time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '项目指南建议' })
  'guide': string = undefined;
  @ApiProperty({ description: '审核时间' })
  'time': string = undefined;
}

export class QVO_guideRecord extends FVO_guideRecord {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_guideRecord {
  @ApiProperty({ description: '项目指南建议' })
  @Rule(RuleType['string']().empty(''))
  'guide': string = undefined;
  @ApiProperty({ description: '审核时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '审核状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '审核意见' })
  @Rule(RuleType['string']().empty(''))
  'desc': string = undefined;
  @ApiProperty({ description: '操作人' })
  @Rule(RuleType['string']().empty(''))
  'operator': string = undefined;
}

export class CVO_guideRecord extends FVO_guideRecord {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_guideRecord extends CDTO_guideRecord {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_guideRecord extends FVO_guideRecord {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
