import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_otherAward {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '成果类型' })
  'type': string = undefined;
  @ApiProperty({ description: '成果编号' })
  'no': string = undefined;
  @ApiProperty({ description: '成果名称' })
  'name': string = undefined;
  @ApiProperty({ description: '完成人' })
  'participants': Array<any> = undefined;
  @ApiProperty({ description: '完成单位' })
  'company': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '发表时间' })
  'time': string = undefined;
}

export class QDTO_otherAward extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user', 'science', 'type', 'no', 'name', 'company', 'time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '成果类型' })
  'type': string = undefined;
  @ApiProperty({ description: '成果编号' })
  'no': string = undefined;
  @ApiProperty({ description: '成果名称' })
  'name': string = undefined;
  @ApiProperty({ description: '完成单位' })
  'company': string = undefined;
  @ApiProperty({ description: '发表时间' })
  'time': string = undefined;
}

export class QVO_otherAward extends FVO_otherAward {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_otherAward {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  @Rule(RuleType['string']().empty(''))
  'science': string = undefined;
  @ApiProperty({ description: '成果类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '成果编号' })
  @Rule(RuleType['string']().empty(''))
  'no': string = undefined;
  @ApiProperty({ description: '成果名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '完成人' })
  @Rule(RuleType['array']().empty(''))
  'participants': Array<any> = undefined;
  @ApiProperty({ description: '完成单位' })
  @Rule(RuleType['string']().empty(''))
  'company': string = undefined;
  @ApiProperty({ description: '研究方向' })
  @Rule(RuleType['string']().empty(''))
  'direction': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '发表时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
}

export class CVO_otherAward extends FVO_otherAward {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_otherAward extends CDTO_otherAward {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_otherAward extends FVO_otherAward {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
