import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_paper {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '论文题目' })
  'title': string = undefined;
  @ApiProperty({ description: '期刊及卷号' })
  'number': string = undefined;
  @ApiProperty({ description: '论文类别' })
  'type': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '作者' })
  'author': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '发表时间' })
  'time': string = undefined;
}

export class QDTO_paper extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user', 'science', 'title', 'type', 'direction', 'author'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '论文题目' })
  'title': string = undefined;
  @ApiProperty({ description: '论文类别' })
  'type': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '作者' })
  'author': string = undefined;
}

export class QVO_paper extends FVO_paper {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_paper {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  @Rule(RuleType['string']().empty(''))
  'science': string = undefined;
  @ApiProperty({ description: '论文题目' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '期刊及卷号' })
  @Rule(RuleType['string']().empty(''))
  'number': string = undefined;
  @ApiProperty({ description: '论文类别' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '研究方向' })
  @Rule(RuleType['string']().empty(''))
  'direction': string = undefined;
  @ApiProperty({ description: '作者' })
  @Rule(RuleType['string']().empty(''))
  'author': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '发表时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
}

export class CVO_paper extends FVO_paper {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_paper extends CDTO_paper {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_paper extends FVO_paper {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
