import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_personnel {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '称号' })
  'nickname': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '获批时间' })
  'time': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
}

export class QDTO_personnel extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user', 'science', 'name', 'nickname', 'direction', 'time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '称号' })
  'nickname': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '获批时间' })
  'time': string = undefined;
}

export class QVO_personnel extends FVO_personnel {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_personnel {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  @Rule(RuleType['string']().empty(''))
  'science': string = undefined;
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '称号' })
  @Rule(RuleType['string']().empty(''))
  'nickname': string = undefined;
  @ApiProperty({ description: '研究方向' })
  @Rule(RuleType['string']().empty(''))
  'direction': string = undefined;
  @ApiProperty({ description: '获批时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
}

export class CVO_personnel extends FVO_personnel {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_personnel extends CDTO_personnel {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_personnel extends FVO_personnel {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
