import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_report {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '活动名称' })
  'name': string = undefined;
  @ApiProperty({ description: '报告性质' })
  'type': string = undefined;
  @ApiProperty({ description: '是否采纳' })
  'is_adopt': string = undefined;
  @ApiProperty({ description: '反馈信息' })
  'message': string = undefined;
  @ApiProperty({ description: '备注' })
  'content': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
}

export class QDTO_report extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user', 'science', 'name', 'type'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '活动名称' })
  'name': string = undefined;
  @ApiProperty({ description: '报告性质' })
  'type': string = undefined;
}

export class QVO_report extends FVO_report {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_report {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  @Rule(RuleType['string']().empty(''))
  'science': string = undefined;
  @ApiProperty({ description: '活动名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '报告性质' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '是否采纳' })
  @Rule(RuleType['string']().empty(''))
  'is_adopt': string = undefined;
  @ApiProperty({ description: '反馈信息' })
  @Rule(RuleType['string']().empty(''))
  'message': string = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
}

export class CVO_report extends FVO_report {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_report extends CDTO_report {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_report extends FVO_report {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
