import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_science {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户信息' })
  'user': string = undefined;
  @ApiProperty({ description: '依托单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '项目名称' })
  'name': string = undefined;
  @ApiProperty({ description: '开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '项目来源' })
  'source': string = undefined;
  @ApiProperty({ description: '项目号' })
  'no': string = undefined;
  @ApiProperty({ description: '经费' })
  'money': number = undefined;
  @ApiProperty({ description: '负责人' })
  'fzuser': string = undefined;
  @ApiProperty({ description: '主要参加人' })
  'participants': Array<any> = undefined;
  @ApiProperty({ description: '核心成员所占比例' })
  'percent': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '转化效益（万元）' })
  'tran_money': number = undefined;
  @ApiProperty({ description: '项目来源2' })
  'source_two': string = undefined;
  @ApiProperty({ description: '项目总人数' })
  'person_num': number = undefined;
  @ApiProperty({ description: '项目来源文本' })
  'source_text': string = undefined;
  @ApiProperty({ description: '状态' })
  'state': string = undefined;
  @ApiProperty({ description: '立项标准部门（单位）' })
  'dept': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
}

export class QDTO_science extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'user',
      'unit',
      'name',
      'start_time',
      'end_time',
      'source',
      'no',
      'fzuser',
      'direction',
      'source_two',
      'state',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户信息' })
  'user': string = undefined;
  @ApiProperty({ description: '依托单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '项目名称' })
  'name': string = undefined;
  @ApiProperty({ description: '开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '项目来源' })
  'source': string = undefined;
  @ApiProperty({ description: '项目号' })
  'no': string = undefined;
  @ApiProperty({ description: '负责人' })
  'fzuser': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '项目来源2' })
  'source_two': string = undefined;
  @ApiProperty({ description: '状态' })
  'state': string = undefined;
}

export class QVO_science extends FVO_science {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_science {
  @ApiProperty({ description: '用户信息' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '依托单位' })
  @Rule(RuleType['string']().empty(''))
  'unit': string = undefined;
  @ApiProperty({ description: '项目名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '开始时间' })
  @Rule(RuleType['string']().empty(''))
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  @Rule(RuleType['string']().empty(''))
  'end_time': string = undefined;
  @ApiProperty({ description: '项目来源' })
  @Rule(RuleType['string']().empty(''))
  'source': string = undefined;
  @ApiProperty({ description: '项目号' })
  @Rule(RuleType['string']().empty(''))
  'no': string = undefined;
  @ApiProperty({ description: '经费' })
  @Rule(RuleType['number']().empty(''))
  'money': number = undefined;
  @ApiProperty({ description: '负责人' })
  @Rule(RuleType['string']().empty(''))
  'fzuser': string = undefined;
  @ApiProperty({ description: '主要参加人' })
  @Rule(RuleType['array']().empty(''))
  'participants': Array<any> = undefined;
  @ApiProperty({ description: '核心成员所占比例' })
  @Rule(RuleType['string']().empty(''))
  'percent': string = undefined;
  @ApiProperty({ description: '研究方向' })
  @Rule(RuleType['string']().empty(''))
  'direction': string = undefined;
  @ApiProperty({ description: '转化效益（万元）' })
  @Rule(RuleType['number']().empty(''))
  'tran_money': number = undefined;
  @ApiProperty({ description: '项目来源2' })
  @Rule(RuleType['string']().empty(''))
  'source_two': string = undefined;
  @ApiProperty({ description: '项目总人数' })
  @Rule(RuleType['number']().empty(''))
  'person_num': number = undefined;
  @ApiProperty({ description: '项目来源文本' })
  @Rule(RuleType['string']().empty(''))
  'source_text': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'state': string = undefined;
  @ApiProperty({ description: '立项标准部门（单位）' })
  @Rule(RuleType['string']().empty(''))
  'dept': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
}

export class CVO_science extends FVO_science {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_science extends CDTO_science {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_science extends FVO_science {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
