import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_sciencePopularize {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '活动主题' })
  'name': string = undefined;
  @ApiProperty({ description: '活动开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '活动结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '参与人数' })
  'person_num': number = undefined;
  @ApiProperty({ description: '宣传报导' })
  'propaganda': string = undefined;
  @ApiProperty({ description: '工作人员人数' })
  'self_num': number = undefined;
  @ApiProperty({ description: '备注' })
  'content': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
}

export class QDTO_sciencePopularize extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user', 'science', 'name', 'start_time', 'end_time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '活动主题' })
  'name': string = undefined;
  @ApiProperty({ description: '活动开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '活动结束时间' })
  'end_time': string = undefined;
}

export class QVO_sciencePopularize extends FVO_sciencePopularize {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_sciencePopularize {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  @Rule(RuleType['string']().empty(''))
  'science': string = undefined;
  @ApiProperty({ description: '活动主题' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '活动开始时间' })
  @Rule(RuleType['string']().empty(''))
  'start_time': string = undefined;
  @ApiProperty({ description: '活动结束时间' })
  @Rule(RuleType['string']().empty(''))
  'end_time': string = undefined;
  @ApiProperty({ description: '参与人数' })
  @Rule(RuleType['number']().empty(''))
  'person_num': number = undefined;
  @ApiProperty({ description: '宣传报导' })
  @Rule(RuleType['string']().empty(''))
  'propaganda': string = undefined;
  @ApiProperty({ description: '工作人员人数' })
  @Rule(RuleType['number']().empty(''))
  'self_num': number = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
}

export class CVO_sciencePopularize extends FVO_sciencePopularize {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_sciencePopularize extends CDTO_sciencePopularize {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_sciencePopularize extends FVO_sciencePopularize {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
