import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_sjActivity {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '活动名称' })
  'name': string = undefined;
  @ApiProperty({ description: '充当角色' })
  'role': string = undefined;
  @ApiProperty({ description: '人数' })
  'person_num': number = undefined;
  @ApiProperty({ description: '宣传报道' })
  'propaganda': string = undefined;
  @ApiProperty({ description: '作者备注' })
  'content': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
}

export class QDTO_sjActivity extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user', 'science', 'name'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  'science': string = undefined;
  @ApiProperty({ description: '活动名称' })
  'name': string = undefined;
}

export class QVO_sjActivity extends FVO_sjActivity {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_sjActivity {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '项目' })
  @Rule(RuleType['string']().empty(''))
  'science': string = undefined;
  @ApiProperty({ description: '活动名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '充当角色' })
  @Rule(RuleType['string']().empty(''))
  'role': string = undefined;
  @ApiProperty({ description: '人数' })
  @Rule(RuleType['number']().empty(''))
  'person_num': number = undefined;
  @ApiProperty({ description: '宣传报道' })
  @Rule(RuleType['string']().empty(''))
  'propaganda': string = undefined;
  @ApiProperty({ description: '作者备注' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
}

export class CVO_sjActivity extends FVO_sjActivity {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_sjActivity extends CDTO_sjActivity {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_sjActivity extends FVO_sjActivity {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
