import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_unit {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户名' })
  'name': string = undefined;
  @ApiProperty({ description: '联系电话' })
  'phone': string = undefined;
  @ApiProperty({ description: '地址' })
  'address': string = undefined;
}

export class QDTO_unit extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'phone', 'address'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户名' })
  'name': string = undefined;
  @ApiProperty({ description: '联系电话' })
  'phone': string = undefined;
  @ApiProperty({ description: '地址' })
  'address': string = undefined;
}

export class QVO_unit extends FVO_unit {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_unit {
  @ApiProperty({ description: '用户名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '联系电话' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
}

export class CVO_unit extends FVO_unit {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_unit extends CDTO_unit {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_unit extends FVO_unit {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
