import { Provide, Inject } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { GuideRecord } from '../entity/guideRecord.entity';
import { JwtService } from '@midwayjs/jwt';
import get = require('lodash/get');
type modelType = ReturnModelType<typeof GuideRecord>;
@Provide()
export class GuideRecordService extends BaseService<modelType> {
  @Inject()
  jwtService: JwtService;

  @InjectEntityModel(GuideRecord)
  model: modelType;

  async beforeCreate(body) {
    if (!body.operator) {
      const token = get(this.ctx, 'request.header.token');
      const ui: any = await this.jwtService.decode(token);
      body.operator = ui._id;
    }
    return body;
  }
}
