import { Provide, Inject } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
const assert = require('assert');
import { Context } from '@midwayjs/koa';
import { Basic } from '../entity/basic.entity';
import { Achieve } from '../entity/achieve.entity';
import { Award } from '../entity/award.entity';
import { Doctor } from '../entity/doctor.entity';
import { OtherAward } from '../entity/otherAward.entity';
import { Outcome } from '../entity/outcome.entity';
import { Paper } from '../entity/paper.entity';
import { Personnel } from '../entity/personnel.entity';
import { Report } from '../entity/report.entity';
import { Science } from '../entity/science.entity';
import { SciencePopularize } from '../entity/sciencePopularize.entity';
import { SjActivity } from '../entity/sjActivity.entity';
import { Title } from '../entity/title.entity';
type modelType1 = ReturnModelType<typeof Basic>;
type modelType2 = ReturnModelType<typeof Achieve>;
type modelType3 = ReturnModelType<typeof Award>;
type modelType4 = ReturnModelType<typeof Doctor>;
type modelType5 = ReturnModelType<typeof OtherAward>;
type modelType6 = ReturnModelType<typeof Outcome>;
type modelType7 = ReturnModelType<typeof Paper>;
type modelType8 = ReturnModelType<typeof Personnel>;
type modelType9 = ReturnModelType<typeof Report>;
type modelType10 = ReturnModelType<typeof Science>;
type modelType11 = ReturnModelType<typeof SciencePopularize>;
type modelType12 = ReturnModelType<typeof SjActivity>;
type modelType13 = ReturnModelType<typeof Title>;
import { ReturnModelType } from '@typegoose/typegoose';
@Provide()
export class ViewService {
  @Inject()
  ctx: Context;
  @InjectEntityModel(Basic)
  basicModel: modelType1;
  @InjectEntityModel(Achieve)
  achieveModel: modelType2;
  @InjectEntityModel(Award)
  awardModel: modelType3;
  @InjectEntityModel(Doctor)
  doctorModel: modelType4;
  @InjectEntityModel(OtherAward)
  otherAwardModel: modelType5;
  @InjectEntityModel(Outcome)
  outcomeModel: modelType6;
  @InjectEntityModel(Paper)
  paperModel: modelType7;
  @InjectEntityModel(Personnel)
  personnelModel: modelType8;
  @InjectEntityModel(Report)
  reportModel: modelType9;
  @InjectEntityModel(Science)
  scienceModel: modelType10;
  @InjectEntityModel(SciencePopularize)
  sciencePopularizeModel: modelType11;
  @InjectEntityModel(SjActivity)
  sjActivityModel: modelType12;
  @InjectEntityModel(Title)
  titleModel: modelType13;
  /**
   * 管理员查询项目内容
   * @param {Object} param 地址参数
   * @param param.id 项目id
   */
  async dataView({ id }) {
    assert(id, '缺少用户信息');
    // 有了要查询的目标,要查:
    // 项目信息;论文列表;其他成果列表;获奖情况列表;成果转化列表;
    // 省部级以上活动;科普活动列表;发表/提交报告列表
    // 省部级以上人才称号;职称晋升;博硕培养
    // 重要进展及重大报告列表
    const query = { science: id };

    // const service = this.ctx.scienceModel;
    // const { populate } = service.getRefMods();
    const science = await this.scienceModel.findById(id);
    const paperList = await this.getList(query, 'paper');
    const otherAwardList = await this.getList(query, 'otherAward');
    const awardList = await this.getList(query, 'award');
    const outcomeList = await this.getList(query, 'outcome');
    const sjActivityList = await this.getList(query, 'sjActivity');
    const sciencePopularizeList = await this.getList(
      query,
      'sciencePopularize'
    );
    const reportList = await this.getList(query, 'report');
    const titleList = await this.getList(query, 'title');
    const doctorList = await this.getList(query, 'doctor');
    const personnelList = await this.getList(query, 'personnel');
    const achieveList = await this.getList(query, 'achieve');

    return {
      achieveList,
      personnelList,
      doctorList,
      titleList,
      reportList,
      sciencePopularizeList,
      science,
      paperList,
      otherAwardList,
      awardList,
      outcomeList,
      sjActivityList,
    };
  }

  async getList(query, modelName) {
    let model;
    if (modelName === 'paper') model = this.paperModel;
    else if (modelName === 'otherAward') model = this.otherAwardModel;
    else if (modelName === 'sjActivity') model = this.sjActivityModel;
    else if (modelName === 'award') model = this.awardModel;
    else if (modelName === 'outcome') model = this.outcomeModel;
    else if (modelName === 'sciencePopularize')
      model = this.sciencePopularizeModel;
    else if (modelName === 'report') model = this.reportModel;
    else if (modelName === 'title') model = this.titleModel;
    else if (modelName === 'doctor') model = this.doctorModel;
    else if (modelName === 'personnel') model = this.personnelModel;
    else if (modelName === 'achieve') model = this.achieveModel;
    if (!model) return [];
    let list = await model.find(query);
    if (list.length <= 0) return [];
    list = JSON.parse(JSON.stringify(list));
    return list;
  }
}
